<?xml version='1.0' encoding='UTF-8' ?>
<!--
@author pedro.garcia
@description Composite component para pintar combos de selección de departamento y municipio

attributes:
valuesAreRequired  define si el required de los selects está en true o false

-->

<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:p="http://primefaces.org/ui"
      xmlns:composite="http://java.sun.com/jsf/composite">

    <composite:interface>

        <composite:attribute name="valuesAreRequired" required="false" default="false"
                             shortDescription="es el valor del atributo 'required' en cada select"/>
        <composite:attribute name="additionalClassForDept" required="false" default="false"
                             shortDescription="es el valor del atributo 'required' en la vista del select de Departamento"/>                                          
        <composite:attribute name="zonaIsRequired" required="false" default="true"
                             shortDescription="determina si es obligatoria la zona o no"/>
        <composite:attribute name="vertical" required="false" default="false" 
                             shortDescription="para definir si se muestra horizontal o vertical"/>
        <composite:attribute name="useZona" required="false" default="false"
                             shortDescription="para definir si se muestra el combo de zonas"/>
        <composite:attribute name="customDeptoAction" required="false" default="false"
                             shortDescription="true para usar un metodo personalizado en la seleccion de depto."/>
        <composite:attribute name="onDeptoSelected" shortDescription="accion ejecutada cuando se selecciona un depto"
                             method-signature="void action()" />
        <composite:attribute name="customMunAction" required="false" default="false"
                             shortDescription="true para usar un metodo personalizado en la seleccion de municipio."/>
        <composite:attribute name="onMunSelected" shortDescription="accion ejecutada cuando se selecciona un municipio"
                             method-signature="void action()" />
        <composite:attribute name="aditionalUpdateDepto" required="false" 
                             shortDescription="Componentes a actualizar al seleccionar deptos"/>
        <composite:attribute name="aditionalUpdateMun" required="false" 
                             shortDescription="Componentes a actualizar al seleccionar municipios"/>

    </composite:interface>

    <composite:implementation>

        <h:panelGrid columns="#{cc.attrs.vertical eq true?2:6}"  
                     columnClasses="colPequena, colMediana">
            <h:panelGroup>
                <h:outputLabel value="Departamento: " styleClass="outputLabelStyle" rendered="#{!cc.attrs.additionalClassForDept}"/>
                <h:outputLabel value="Departamento: " styleClass="outputLabelStyle labelRequired" rendered="#{cc.attrs.additionalClassForDept}"/>
                <h:outputLabel value="* " styleClass="requiredLabelStyle"
                               rendered="#{cc.attrs.valuesAreRequired}"/>                             
            </h:panelGroup>
            <h:panelGroup>
                <h:panelGrid columns="3" cellspacing="0">
                    <h:selectOneMenu id="departamentoSeleccionadoCustom" label="Departamento" rendered="#{cc.attrs.customDeptoAction}"
                                     value="#{combosDeptosMunis.selectedDepartamentoCod}" 
                                     required="#{cc.attrs.valuesAreRequired}">
                        <f:selectItems value="#{combosDeptosMunis.departamentosItemList}" />
                        <p:ajax process="@this" update="municipioSeleccionado, municipioSeleccionadoCus, #{cc.attrs.aditionalUpdateDepto}" 
                                listener="#{cc.attrs.onDeptoSelected}" />
                    </h:selectOneMenu>

                    <h:selectOneMenu id="departamentoSeleccionado" label="Departamento" rendered="#{!cc.attrs.customDeptoAction}"
                                     value="#{combosDeptosMunis.selectedDepartamentoCod}" 
                                     required="#{cc.attrs.valuesAreRequired}">
                        <f:selectItems value="#{combosDeptosMunis.departamentosItemList}" />
                        <p:ajax process="@this" update="municipioSeleccionado, municipioSeleccionadoCus, #{cc.attrs.aditionalUpdateDepto}" 
                                listener="#{combosDeptosMunis.onChangeDepartamentosListener}" />
                    </h:selectOneMenu>

                    <p:message id="departamentoMsg" for="departamentoSeleccionado"
                               display="icon" />
                    <p:commandLink id="btnOrdenDepartamentos"
                                   update="btnOrdenDepartamentos, departamentoSeleccionado"
                                   title="Ordenar departamentos"
                                   action="#{combosDeptosMunis.cambiarOrdenDepartamentos}"
                                   ajax="true" immediate="true">
                        <p:graphicImage
                            rendered="#{combosDeptosMunis.departamentosOrderedByNombre}"
                            style="border: none" value="/images/sortCode.png" />
                        <p:graphicImage
                            rendered="#{!combosDeptosMunis.departamentosOrderedByNombre}"
                            style="border: none" value="/images/sortText.png" />
                    </p:commandLink>
                </h:panelGrid>
            </h:panelGroup>

            <h:panelGroup>
                <h:outputLabel value="Municipio: " styleClass="outputLabelStyle" />
                <h:outputLabel value="* " styleClass="requiredLabelStyle"
                               rendered="#{cc.attrs.valuesAreRequired}"/>
            </h:panelGroup>
            <h:panelGroup>
                <h:panelGrid columns="3"  cellspacing="0">
                    <h:selectOneMenu id="municipioSeleccionadoCus" label="Municipio cus"  rendered="#{cc.attrs.customMunAction}"
                                     value="#{combosDeptosMunis.selectedMunicipioCod}" 
                                     required="#{cc.attrs.valuesAreRequired}">
                        <f:selectItems value="#{combosDeptosMunis.municipiosItemList}" />
                        <p:ajax process="@this" update="zonaSeleccionada, #{cc.attrs.aditionalUpdateMun}"
                                listener="#{cc.attrs.onMunSelected}" />

                    </h:selectOneMenu>

                    <h:selectOneMenu id="municipioSeleccionado" label="Municipio" rendered="#{!cc.attrs.customMunAction}"
                                     value="#{combosDeptosMunis.selectedMunicipioCod}" 
                                     required="#{cc.attrs.valuesAreRequired}">
                        <f:selectItems value="#{combosDeptosMunis.municipiosItemList}" />
                        <p:ajax process="@this" update="zonaSeleccionada, #{cc.attrs.aditionalUpdateMun}"
                                listener="#{combosDeptosMunis.onChangeMunicipiosListener}" />

                    </h:selectOneMenu>

                    <p:message id="municipioMsg" for="municipioSeleccionado" display="icon" />
                    <p:commandLink id="btnOrdenMunicipios"
                                   update="btnOrdenMunicipios, municipioSeleccionado"
                                   title="Ordenar municipios"
                                   action="#{combosDeptosMunis.cambiarOrdenMunicipios}" ajax="true"
                                   immediate="true">
                        <p:graphicImage
                            rendered="#{combosDeptosMunis.municipiosOrderedByNombre}"
                            style="border: none" value="/images/sortCode.png" />
                        <p:graphicImage
                            rendered="#{!combosDeptosMunis.municipiosOrderedByNombre}"
                            style="border: none" value="/images/sortText.png" />
                    </p:commandLink>
                </h:panelGrid>
            </h:panelGroup>

        </h:panelGrid>

        <h:panelGroup rendered="#{cc.attrs.useZona}">
            <h:panelGrid columns="#{cc.attrs.vertical eq true?2:6}" cellspacing="7" 
                         columnClasses="colPequena, colMediana">
                <h:panelGroup>
                    <h:outputLabel value="Zona: " styleClass="outputLabelStyle" />
                    <h:outputLabel value="* " styleClass="requiredLabelStyle"
                                   rendered="#{cc.attrs.valuesAreRequired and cc.attrs.zonaIsRequired}"/>
                </h:panelGroup>
                <h:panelGrid columns="3" cellspacing="0">
                    <h:selectOneMenu id="zonaSeleccionada" label="Zona"
                                     value="#{combosDeptosMunis.selectedZonaCod}"
                                     required="#{cc.attrs.valuesAreRequired and cc.attrs.zonaIsRequired}">
                        <f:selectItems value="#{combosDeptosMunis.zonasItemList}" />
                        <p:ajax process="@this" />
                    </h:selectOneMenu>
                    <p:message id="zonaMsg" for="zonaSeleccionada" display="icon" />
                    <p:commandLink id="btnOrdenZonas"
                                   update="btnOrdenZonas, zonaSeleccionada"
                                   title="Ordenar zonas"
                                   action="#{combosDeptosMunis.cambiarOrdenZonas}" ajax="true"
                                   immediate="true">
                        <p:graphicImage
                            rendered="#{combosDeptosMunis.zonasOrderedByNombre}"
                            style="border: none" value="/images/sortCode.png" />
                        <p:graphicImage
                            rendered="#{!combosDeptosMunis.zonasOrderedByNombre}"
                            style="border: none" value="/images/sortText.png" />
                    </p:commandLink>
                </h:panelGrid>
            </h:panelGrid>
        </h:panelGroup>


    </composite:implementation>

</html>
